﻿
#Region "FileHeader"
#If False Then
führt den Action(Of Form) - Callback zum frühestmöglichen Zeitpunkt aus, wenn das Control - mittelbar - auf einem Form aufsitzt.
#End If '-- Options, Imports
#End Region 'FileHeader

Public Class FormConnectAction

   Private WithEvents _Ctl As Control
   Private _Action As Action(Of Form)

   Private Sub New(ctl As Control, Action As Action(Of Form))
      Dim top = GetTopControl(ctl)
      Dim frm = TryCast(top, Form)
      If frm.NotNull Then Action(frm) : Return
      _Ctl = top
      _Action = Action
   End Sub

   Private Function GetTopControl(ctl As Control) As Control
      Do
         Dim c = ctl
         ctl = ctl.Parent
         If ctl.Null Then Return c
      Loop
   End Function

   Private Sub _Ctl_ParentChanged(sender As Object, e As EventArgs) Handles _Ctl.ParentChanged
      Dim top As Control = Nothing
      Try
         top = GetTopControl(_Ctl)
      Catch ex As Exception
         Return
      End Try
      Dim frm = TryCast(top, Form)
      If frm.Null Then
         _Ctl = top
      Else
         _Action(frm)
         _Ctl = Nothing
      End If
   End Sub

   Public Shared Sub SetAction(ctl As Control, action As Action(Of Form))
      Dim x = New FormConnectAction(ctl, action)
   End Sub
End Class
